from cbr_athena.dbs.DB__CBR__Content import DB__CBR__Content
from cbr_athena.fastapi.routes.Fast_API_Route import Fast_API__Routes
from osbot_utils.decorators.methods.cache_on_self import cache_on_self
from osbot_utils.utils.Env import load_dotenv


class Routes__Content(Fast_API__Routes):
    path_prefix: str = "content"

    def __init__(self):
        super().__init__()
        load_dotenv()
        # self.db_cbr_content      = DB__CBR__Content   ()              #.setup()
        # DB__CBR__Content().setup()                                    # can't create the db here since we hit on a sqlite thread issue

    @cache_on_self
    def db_cbr_content(self):
        return DB__CBR__Content().setup()
        #db_cbr_content.setup()

    def add_routes(self):

        @self.router.get('/cybersecurity_in_the_boardroom')
        def content__cybersecurity_in_the_boardroom():

            #cbr_api_request.log_message('in content__cybersecurity_in_the_boardroom')

            file_path = 'docs/content/1-cybersecurity-in-the-boardroom.md'
            return self.db_cbr_content().db_file_contents(file_path)
            #return self.repo__cbr_athena.content__cybersecurity_in_the_boardroom()

        @self.router.get('/building_a_cybersecure_organisation')
        def content__building_a_cybersecure_organisation():
            # print()
            # for file in self.db_cbr_content.files():
            #     print(file.get('path'))
            file_path='docs/content/2-building-a-cybersecure-organisation.md'
            return self.db_cbr_content().db_file_contents(file_path)
            #return self.repo__cbr_athena.content__building_a_cybersecure_organisation()


        @self.router.get('/incident_management')
        def content__incident_management():
            file_path = 'docs/content/3-Incident-management.md'
            return self.db_cbr_content().db_file_contents(file_path)
            #return self.repo__cbr_athena.content__incident_management()

        @self.router.get('/importance_of_digital_trust')
        def content__importance_of_digital_trust():
            file_path = 'docs/content/4-the-importance-of-digital-trust.md'
            return self.db_cbr_content().db_file_contents(file_path)
            #return self.repo__cbr_athena.content__importance_of_digital_trust()